/* Copyright (C) 2000-2015 Lavtech.com corp. All rights reserved.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA 
*/

#ifndef _UDM_COORDS_H
#define _UDM_COORDS_H

void UdmURLCRDListSortByURLThenSecnoThenPos(UDM_URLCRDLIST *L);
udm_rc_t UdmAddOneCoord(UDM_URLCRDLIST *CoordList, const UDM_URL_CRD *Coord);
udm_rc_t UdmCoordListMultiUnpack(UDM_URLCRDLIST *CoordList,
                                 UDM_URL_CRD *CoordTemplate,
                                 const unsigned char *intag, size_t lintag,
                                 udm_bool_t save_section_size);
udm_rc_t UdmURLCRDListListAddWithSort2(UDM_SEARCHSECTIONLISTLIST *SectionListList,
                                       UDM_WIDEWORDLIST *WWList,
                                       UDM_WIDEWORD *Word,
                                       UDM_URLCRDLIST *CoordList);
udm_rc_t UdmMultiWordAdd(UDM_SEARCHSECTIONLISTLIST *SectionListList,
                         UDM_WIDEWORDLIST *WWList,
                         UDM_WIDEWORD *Word,
                         UDM_URLID_LIST *Limit,
                         UDM_SEARCHSECTIONLISTLIST *OriginalSectionListList,
                         size_t orig_wordnum, size_t nparts);

/* Coord pack/unpack routines */
size_t udm_coord_put(size_t wc, unsigned char *r, unsigned char *e);
size_t udm_coord_get(size_t *wc, const unsigned char *s, const unsigned char *e);
size_t udm_coord_get_quick(size_t *pwc, const unsigned char *s);
const unsigned char *udm_coord_sum(size_t *sump,
                                   const unsigned char *s,
                                   const unsigned char *e,
                                   size_t n);
const unsigned char *
udm_coord_skip(const unsigned char *s, const unsigned char *e, size_t n);
UDM_COORD2 *UdmPackedCoordsToUnpackedCoords(const unsigned char *s,
                                            const unsigned char *e,
                                            size_t nrecs,
                                            UDM_COORD2 *C,
                                            UDM_COORD2 *Coord,
                                            const unsigned char **end);

#endif /* _UDM_COORDS_H */
