/* Copyright (C) 2000-2015 Lavtech.com corp. All rights reserved.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA 
*/

#include "udm_config.h"

#include <stdlib.h>
#include <fcntl.h>
#include <string.h>
#include <sys/types.h>
#ifdef HAVE_UNISTD_H
#include <unistd.h>
#endif
#ifdef HAVE_IO_H
#include <io.h>
#endif

#include <stdio.h>

#include "udm_common.h"
#include "udm_query.h"
#include "udm_boolean.h"
#include "udm_word.h"
#include "udm_result.h"
#include "udm_searchtool.h"


void
UdmQueryInit(UDM_QUERY *Query)
{
  bzero((void*) Query, sizeof(*Query));
}


void
UdmQueryClearLimits(UDM_QUERY *Query)
{
  UDM_FREE(Query->from);
  UDM_FREE(Query->where);  
}


void
UdmQueryFree(UDM_QUERY *Query)
{
  UdmBoolExprFree(&Query->BoolExpr);
  UdmResultFree(&Query->Res);
  UdmURLDataListFree(&Query->URLData);
  UDM_FREE(Query->StatList.Stat);
  bzero((void*) &Query->StatList, sizeof(Query->StatList));
  UdmQueryClearLimits(Query);
  UdmSearchSectionListFree(&Query->SectionList);
  UDM_FREE(Query->where);
  UDM_FREE(Query->from);
}
